//=============================================================================
// RLCoopS.
//=============================================================================
class RLCoopS extends CoopGame
	Config(RLCoopS);

#exec obj load file="System\RLMelee.u"

#exec TEXTURE IMPORT NAME=I_Bandages FILE=Textures\Icons\I_Bandages.pcx GROUP="Icons"
#exec TEXTURE IMPORT NAME=I_SuperHealth FILE=Textures\Icons\I_SuperHealth.pcx GROUP="Icons"
#exec TEXTURE IMPORT NAME=RLFlashLightDecalModulated1 FILE=Textures\Decals\RLFlashLightDecalModulated1.pcx GROUP="Decals"

struct sSurvivorInventory
{
	var() string		 	Item;
	var() float				Chance;
};
var(RLNewSurvivorGear) 		globalconfig sSurvivorInventory SurvivorInventory[20];
var(RLAccuracySettings) 	globalconfig float BaseAccuracy, MovementModifier, CrouchModifier;
var(RLAccuracySettings) 	globalconfig float Recoil;
var(RLSettings) 			globalconfig bool bNewPlayersSpawnRandomly;
var(RLSuperRealSettings) 	globalconfig float HeartAttackChanceRate;

var Bool bKeepInventory;
var bool bStarted;

/*struct SavedPlayer
{
	var string PlayerIP;
	var string LastMapName;
	var Array<string> PlayerInventory;
};
var config travel Array<SavedPlayer> SavedPlayers;*/

var travel config Array<String> DeadPlayers;
var travel config Array<String> DeadMaps;

Replication
{
	Reliable if(Role==ROLE_Authority)
		bStarted, Recoil;
}

Struct sPlayerInfo
{
	var string PlayerName;
	var int Deaths;
};
var globalconfig Array<sPlayerInfo> PlayerInfo;

function bool ShouldRespawn(Actor Other)
{ return false; }

function bool AllowsBroadcast(actor broadcaster, int Len)
{
	SentText += Len;
	return (SentText < 260) || (Level.Pauser!="");
}

function int GetDeaths(string pName)
{
	local int I;
	if(Array_Size(PlayerInfo)>0)
	For(I=0; I<Array_Size(PlayerInfo); I++)
	if(PlayerInfo[I].PlayerName~=pName)
		return PlayerInfo[I].Deaths;
	
	return 0;
}

function int AddDeath(string pName)
{
	local int I;
	
	if(Array_Size(PlayerInfo)<=0) return 0;
	For(I=0; I<Array_Size(PlayerInfo); I++)
	if(PlayerInfo[I].PlayerName~=pName)
	{ PlayerInfo[I].Deaths++; SaveConfig(); return PlayerInfo[I].Deaths; }
	Array_Insert(PlayerInfo,Array_Size(PlayerInfo));
	PlayerInfo[Array_Size(PlayerInfo)-1].PlayerName=pName;
	PlayerInfo[Array_Size(PlayerInfo)-1].Deaths=1;
	SaveConfig();
	return 0;
}

simulated function postbeginplay()
{
	spawn(class'RLCoopS.RLGameRules');
	spawn(class'RLCoopS.RLCoopSMut');
	super.postbeginplay();
	SaveConfig();
}






function DiscardInventory(Pawn Other)
{
 local actor dropped;
 local inventory Inv,Next;
 local weapon weap;
 local float speed;
 
	if(PlayerPawn(Other)!=None)
	{
		For(Inv=Other.Inventory; Inv!=None; Inv=Inv.Inventory)
		if(RLMelee(Inv)==None && RInvHandler(Inv)==None && DefaultAmmo(Inv)==None)
		{
			if(Pickup(Inv)!=None && Pickup(Inv).NumCopies>0)
			While(Pickup(Inv).NumCopies>0)
			{
				Next = spawn(Inv.Class,,,Other.Location, rot(0,65536,0)*FRand());
				Next.RespawnTime=0.0;
				Next.BecomePickup();
				Next.RemoteRole = ROLE_DumbProxy;
				Next.SetPhysics(PHYS_Falling);
				Next.bCollideWorld = true;
				Next.Velocity = Other.Velocity + VRand()*500;
				Next.GotoState('PickUp', 'Dropped');
				Pickup(Inv).NumCopies--;
			}
			
			Other.DeleteInventory(Inv);
			Inv.SetLocation(Other.Location);
			Inv.RespawnTime=0.0;
			Inv.BecomePickup();
			Inv.RemoteRole = ROLE_DumbProxy;
			Inv.SetPhysics(PHYS_Falling);
			Inv.bCollideWorld = true;
			Inv.Velocity = Other.Velocity + VRand()*500;
			Inv.GotoState('PickUp', 'Dropped');
			Inv.SetRotation(rot(0,65536,0)*FRand());
		}
		else Inv.Destroy();
		return;
	}
	
	/*If( Other.IsA('Playerpawn'))
	{
		Other.PendingWeapon = Other.Weapon;
		Other.Weapon.GoToState('');
  		Other.Weapon = None;
		if(RL_Player(Other)!=None && RL_Player(Other).DualWeapon!=None)
		{
			RL_Player(Other).DualWeapon.GoToState('');
  			RL_Player(Other).DualWeapon = None;
		}
		return;
	}*/
	
	if( Other.DropWhenKilled != None )
	{
		dropped = Spawn(Other.DropWhenKilled,,,Other.Location);
		Inv = Inventory(dropped);
		if ( Inv != None )
		{ 
			Inv.RespawnTime = 0.0;
			Inv.BecomePickup();
		}
		if ( dropped != None )
		{
			dropped.RemoteRole = ROLE_DumbProxy;
			dropped.SetPhysics(PHYS_Falling);
			dropped.bCollideWorld = true;
			dropped.Velocity = Other.Velocity + VRand() * 280;
		}
		if ( Inv != None )
			Inv.GotoState('PickUp', 'Dropped');
	}					
	if( (Other.Weapon!=None) && (Other.Weapon.Class!=DefaultWeapon) 
		&& Other.Weapon.bCanThrow )
	{
		speed = VSize(Other.Velocity);
		weap = Other.Weapon;
		weap.Velocity = Normal(Other.Velocity/speed + 0.5 * VRand()) * (speed + 280);
		Other.TossWeapon();
		if ( weap.PickupAmmoCount == 0 )
			weap.PickupAmmoCount = 1;
	}
	for( Inv=Other.Inventory; Inv!=None; Inv=Inv.Inventory )
		Inv.Destroy();
	/*for( Inv=Other.Inventory; Inv!=None; Inv=Next )
	{	
		Next = Inv.Inventory;
		If( !Inv.IsA('xCommands') )
		{
			Other.DeleteInventory(inv);
			Inv.Destroy();
		}
	}*/
}





/*
const JoinTime = 10;

var bool bCantJoin;
var bool Initialized;


simulated function postBeginPlay()
{
  super.postBeginPlay();

  bCantJoin = false;

  if (!Initialized)
  {
      Initialized = true;
	  Enable('Tick');
  }

  if( role==role_authority )
    settimer( JoinTime, false );
}


function timer()
{
	bCantJoin = true;
}




function StartPlayer(PlayerPawn Other)
{

local playerpawn newplayer;

if( bCantJoin ) 
	{
	newplayer.ConsoleCommand("Suicide");
	}

	if ( Level.NetMode==NM_DedicatedServer || Level.NetMode==NM_ListenServer || !bRestartLevel )
	{
		if( Other.Region.Zone.bWaterZone )
			Other.GotoState('PlayerSwimming');
		else Other.GotoState('PlayerWalking');
	}
	else
		Other.ClientTravel( "?restart", TRAVEL_Relative, false );
}

*/

function bool RestartPlayer( pawn aPlayer )

{

//no respawn for u

//aPlayer.ConsoleCommand("viewclass playerpawn");
aPlayer.GotoState('PlayerSpectating');
aPlayer.bMovable=True;

}


function Killed(pawn killer, pawn Other, name damageType)
{
	super.Killed(killer, Other, damageType);
	if(Killer!=None && Killer.PlayerReplicationInfo!=None && (Other.bIsPlayer || Other.IsA('Nali')))
		killer.PlayerReplicationInfo.Score += 2;
	if(RL_Player(Other)!=None)
	{
		Other.PlayerReplicationInfo.Score = AddDeath(Other.PlayerReplicationInfo.PlayerName);
		DeadPlayers[Array_Size(DeadPlayers)] = RLPRI(RL_Player(Other).PlayerReplicationInfo).PlayerIP;
		DeadMaps[Array_Size(DeadMaps)] = GetURLMap();
		SaveConfig();
	}
}

function ScoreKill( Pawn Killer, Pawn Other )
{
    local int numPlayers;
    local PlayerPawn P;

//	super.scorekill(killer, other);

	// Should we make them immobile?
    if (Other.isA('PlayerPawn'))
    {
        PlayerPawn(Other).bMovable = false;
        other.drawtype = DT_None;
		Other.PlayerReplicationInfo.Score+=1;
    }
    else return;
    
    numPlayers = 0;

    foreach AllActors(class'PlayerPawn', P)
    {
 //       if (P.bMovable)
if(P.Health>0 && Spectator(P)==None)
            numPlayers++;
    }

    if(numPlayers==0)
    {
		gameEnd();
    }

}

function gameEnd()
{
	local RLPRI PRI;
	local int I;
	
	ForEach AllActors(class'RLPRI', PRI)
	For(I=0; I<Array_Size(RLCoopS(Level.Game).DeadPlayers); I++)
	if(DeadPlayers[I]==PRI.PlayerIP) { Array_Remove(DeadPlayers,I); Array_Remove(DeadMaps,I); }
	SaveConfig();
	
	gotostate('GameEnded');
}

state gameended
{
ignores gameend;

begin:
	sleep(5.0);
    consolecommand("servertravel "$self.getUrlMap());
    consolecommand("killall rlmenus.rl_throwclientwindow");
}

function bool CheckVotes()
{
	local RLPRI PRI;
	local bool bFoundPlayer;
	
	ForEach AllActors(class'RLPRI', PRI)
	if(!PRI.bIsSpectator)
	{
		bFoundPlayer=True;
		if(!PRI.bVoteEnd) return false;
	}
	ForEach AllActors(class'RLPRI', PRI)
		PRI.bVoteEnd=False;
	Level.Pauser="";
	return true;
}

auto state StartGame
{
begin:
	Sleep(1.0);
	Level.Pauser="VoteStart";
	Sleep(1.0);
	Level.Pauser="";
	bStarted=True;
}

event playerpawn Login(string Portal, string Options, out string Error, class<playerpawn> SpawnClass)
{
	if(ClassIsChildOf(SpawnClass,class'Spectator')) return super.login(Portal, Options, Error, class'RL_RealSpectator');
	if(bStarted) { NumSpectators--; return super.login(Portal, Options, Error, class'RL_Spectator'); }
	
	if(SpawnClass==class'FemaleTwo') return Super.Login(Portal, Options, Error, class'RLCoopS.RL_FemaleTwo');
	else if(SpawnClass==class'MaleOne') return Super.Login(Portal, Options, Error, class'RLCoopS.RL_MaleOne');
	else if(SpawnClass==class'MaleTwo') return Super.Login(Portal, Options, Error, class'RLCoopS.RL_MaleTwo');
	else if(SpawnClass==class'MaleThree') return Super.Login(Portal, Options, Error, class'RLCoopS.RL_MaleThree');
	else return Super.Login(Portal, Options, Error, class'RLCoopS.RL_FemaleOne');
	
	return Super.Login(Portal, Options, Error, class'RL_FemaleOne');
}

function Logout(pawn Exiting)
{
	local RLPRI PRI;
	local inventory Inv;
	local int I,J;
	
	GetAccessManager().AdminLogout(PlayerPawn(Exiting));
	if ( Exiting.IsA('PlayerPawn') && !Exiting.IsA('Spectator') )
		NumPlayers--;
	if ( RL_RealSpectator(Exiting)!=None && Level.NetMode!=NM_StandAlone )
		NumSpectators--;
	if ( Level.NetMode==NM_DedicatedServer || Level.NetMode==NM_ListenServer )
		BroadcastMessage( Exiting.PlayerReplicationInfo.PlayerName$LeftMessage, false );

	if(LocalLog!=None) LocalLog.LogPlayerDisconnect(Exiting);
	if(WorldLog!=None) WorldLog.LogPlayerDisconnect(Exiting);
	
	
	/*PRI = RLPRI(Exiting.PlayerReplicationInfo);
	if(PRI==None || PRI.PlayerIP=="") return;
	I=Array_Size(SavedPlayers);
	SavedPlayers[I].PlayerIP=PRI.PlayerIP;
	SavedPlayers[I].LastMapName=Level.Title;
	For(J=0; J<Array_Size(PRI.PlayerInventory); J++)
	SavedPlayers[I].PlayerInventory[J] = PRI.PlayerInventory[J];
	
	SaveConfig();*/
}

function SendPlayer( PlayerPawn aPlayer, string URL )
{
	local RLPRI PRI;
	local RL_Player P;
	local int I;
	
	if(RL_Player(aPlayer)!=None && !RLPRI(RL_Player(aPlayer).PlayerReplicationInfo).bVoteEnd)
		RL_Player(aPlayer).Vote();
	ForEach AllActors(class'RLPRI', PRI)
	if(!PRI.bVoteEnd && !PRI.bIsSpectator && PRI.Health>0)
	{
		BroadcastMessage(aPlayer.PlayerReplicationInfo.PlayerName @"tried to end, but not everyone voted to end yet!",true,'CriticalEvent');
		return;
	}
	
	ForEach AllActors(class'RLPRI', PRI)
	For(I=0; I<Array_Size(RLCoopS(Level.Game).DeadPlayers); I++)
	if(PRI.PlayerIP!="" && DeadPlayers[I]==PRI.PlayerIP) { Array_Remove(DeadPlayers,I); Array_Remove(DeadMaps,I); }
	SaveConfig();
	
	Super.SendPlayer(aPlayer, URL);
}

Function AddDefaultInventory( pawn PlayerPawn )
{
	local Translator newTranslator;
	local rInvHandler rinv;
	local RLMelee fists;
	local NavigationPoint OldPoint;
	local PlayerStart P;
	local ScriptedPawn E;
	local NavigationPoint N;
	local Array<NavigationPoint> Navs;
	local playerpawn newplayer;
	local int numplayers;
	local Inventory Inv;
	local int I;
	
	
	numPlayers = 0;
	
    foreach AllActors(class'PlayerPawn', newplayer)
    {

	if(newplayer.bMovable && Spectator(newplayer)==None)
            numPlayers++;
    }

    if(numPlayers==0)
    {
		gameEnd();
    }

	PlayerPawn.Weapon=None;
	if(RL_Player(PlayerPawn)!=None)
		RL_Player(PlayerPawn).DualWeapon=None;

//	if ( Level.DefaultGameType != class'VRikersGame' )
//		Super.AddDefaultInventory(PlayerPawn);
	
	// Spawn translator.
	if ( PlayerPawn.IsA('Spectator')) return;
	if ( PlayerPawn.FindInventoryType(class'RLMelee') != None )
		return;
	newTranslator = Spawn(class'Translator',,, PlayerPawn.Location);
	if ( newTranslator != None )
	rinv = Spawn(class'rInvHandler',,, PlayerPawn.Location);
	if ( rinv != None )
	fists = Spawn(class'RLMelee',,, PlayerPawn.Location);
	if ( fists != None )
	{
		newTranslator.GiveTo( PlayerPawn );
		rinv.GiveTo( PlayerPawn );
		fists.GiveTo( PlayerPawn );
		PlayerPawn.SelectedItem = newTranslator;
		newTranslator.PickupFunction(PlayerPawn);
		rinv.PickupFunction(PlayerPawn);
		fists.BringUp();
	}
	
	if(PlayerPawn.Health>0 && !bNewPlayersSpawnRandomly) return;
	ForEach AllActors(class'PlayerStart', P) if(P.bEnabled) Break;
	if(P==None) return;
	
	ForEach AllActors(class'NavigationPoint', N)
	if(PlayerStart(N)==None && Teleporter(N)==None && SpawnPoint(N)==None && !N.Taken && VSize(N.Location-P.Location)<4000 && VSize(N.Location-P.Location)>1000)
	{
		ForEach VisibleCollidingActors(class'ScriptedPawn', E, 1000, N.Location) Break;
		if(E==None) Navs[Array_Size(Navs)]=N;
	}
	
	if(Array_Size(Navs)>0)
	{
		PlayerPawn.SetLocation(Navs[Rand(Array_Size(Navs))].Location);
		PlayerPawn.SetRotation(rot(0,1,0)*Rand(65536));
	}
	UnrealIPlayer(PlayerPawn).ServerFeignDeath();
	PlayerPawn.Health=RandRange(35,75);
	
	For(I=0; I<20; I++)
	if(SurvivorInventory[I].Chance>0.0f && FRand()<SurvivorInventory[I].Chance)
	{
		Inv=Spawn(class<Inventory>(DynamicLoadObject(SurvivorInventory[I].Item,class'Class')),,,PlayerPawn.Location);
		if(Inv!=None) Inv.Touch(PlayerPawn);
		/*{
			Inv.GiveTo(PlayerPawn);
			if(Pickup(Inv)!=None) PlayerPawn.SelectedItem=Inv;
			else if(Weapon(Inv)!=None)
			{
				Weapon(Inv).BringUp();
				Weapon(Inv).GiveAmmo(PlayerPawn);
			}
		}*/
	}
}



function bool PickupQuery( Pawn Other, Inventory item )
{
	local GameRules G;
	local inventory inv;
	local int derp;
	local int LightWeps;
	local int HeavyWeps;
	
	if(GameRules!=None)
	{
		for ( G=GameRules; G!=None; G=G.NextRules )
			if ( G.bHandleInventory && !G.CanPickupInventory(Other,item) )
				Return false;
	}
	if(Other.Inventory == None) return true;
	else If(Item.IsA('Ammo')) return !Other.Inventory.HandlePickupQuery(Item);
	else If(Item.IsA('Weapon'))
	{
		for (Inv=Other.Inventory; Inv!=None; Inv=Inv.Inventory)
		If(inv.IsA('Weapon') && Inv != Item && RLMelee(Inv)==None)
		{
			if(Item.Class==Inv.Class) return !Other.Inventory.HandlePickupQuery(Item);
			else if(Inv.Mass<20) LightWeps++;
			else HeavyWeps++;
		}
		If( (Item.Mass<20 && (LightWeps>=2||HeavyWeps>=2)) || (Item.Mass>=20 && (HeavyWeps>=2 || (HeavyWeps==1&&LightWeps>=1))) )
		{
			Other.ClientMessage("You can not have more than 2 heavy weapons or 2 light and 1 heavy weapon!", 'Pickup');
			Return False;
		}
		else return !Other.Inventory.HandlePickupQuery(Item);
	}
	else If(item.isa('pickup') && pickup(item).bDisplayableInv)
	{
		for(Inv=Other.Inventory; Inv!=None; Inv=Inv.Inventory)
		{
			If(Inv.Class == Item.Class && !Pickup(Item).bCanHaveMultipleCopies)
			{
				Other.ClientMessage("You already have this item!");
				Return False;
			}
			else if(Pickup(Inv)!=None && Ammo(Inv)==None /*&& !Inv.bIsAnArmor && inv!=Item && Inv.bDisplayableInv && Inv.bActivatable*/)
			{
				Derp++;
				if(pickup(inv).bCanHaveMultipleCopies) Derp += pickup(inv).Numcopies;
			}
		}
		If(Derp >= 16)
		{
			Other.ClientMessage("You can not carry more than (15) items!");
			Return False;
		}
		else return !Other.Inventory.HandlePickupQuery(Item);
	}

return true;


/*

If((!Item.IsA('Ammo') && !Item.IsA('Flare') && !Item.IsA('Seeds') && !Item.IsA('rBandages') && !Item.IsA('rHealth')) || Item.IsA('Pickup') && !Item.IsA('Ammo') && !Pickup(Item).bCanHaveMultipleCopies)

*/
}



Simulated function tick(float DT)
{
local weapon ww;

Foreach Allactors(Class'Weapon',ww)
{
If(WW.bTossedOut)
{
WW.bTossedOut=False;
WW.RespawnTime=0;
WW.LifeSpan=0;
}
}

// Super.Tick(DT);


}

defaultproperties
{
				SurvivorInventory(0)=(Item="RLWeapons.RL_DispersionPistol",Chance=0.300000)
				SurvivorInventory(1)=(Item="RLWeapons.RL_Automag",Chance=0.300000)
				SurvivorInventory(2)=(Item="RLWeapons.RL_Stinger",Chance=0.300000)
				SurvivorInventory(3)=(Item="rlcoops.rHealth",Chance=0.400000)
				SurvivorInventory(4)=(Item="rlcoops.rHealth",Chance=0.400000)
				SurvivorInventory(5)=(Item="rlcoops.rBandages",Chance=0.600000)
				SurvivorInventory(6)=(Item="rlcoops.rBandages",Chance=0.600000)
				SurvivorInventory(7)=(Item="UnrealShare.Flare",Chance=0.500000)
				SurvivorInventory(8)=(Item="UnrealShare.Flare",Chance=0.500000)
				SurvivorInventory(9)=(Item="RLCoopS.rFlashlight",Chance=0.300000)
				SurvivorInventory(10)=(Item="UnrealShare.Shellbox",Chance=0.500000)
				SurvivorInventory(11)=(Item="UnrealShare.Shellbox",Chance=0.400000)
				SurvivorInventory(12)=(Item="UnrealShare.Shellbox",Chance=0.300000)
				SurvivorInventory(13)=(Item="UnrealShare.StingerAmmo",Chance=0.300000)
				SurvivorInventory(14)=(Item="UnrealShare.StingerAmmo",Chance=0.300000)
				SurvivorInventory(15)=(Item="RLMelee.RLMeleeKnife",Chance=0.100000)
				BaseAccuracy=0.500000
				MovementModifier=0.700000
				CrouchModifier=0.300000
				Recoil=5.000000
				PlayerInfo(0)=(PlayerName="JPZ",Deaths=8)
				PlayerInfo(1)=(PlayerName="Bleeder91<NL>",Deaths=123)
				PlayerInfo(2)=(PlayerName="Shivaxi",Deaths=306)
				PlayerInfo(3)=(PlayerName="ep5",Deaths=5)
				PlayerInfo(4)=(PlayerName="Jetty",Deaths=2)
				PlayerInfo(5)=(PlayerName="Jet_v4.3.5",Deaths=11)
				PlayerInfo(6)=(PlayerName="lolpnuts",Deaths=11)
				PlayerInfo(7)=(PlayerName="Bunny",Deaths=39)
				PlayerInfo(8)=(PlayerName="WEAREGODS",Deaths=5)
				PlayerInfo(10)=(PlayerName="Player",Deaths=35)
				PlayerInfo(11)=(PlayerName="Gizzy",Deaths=10)
				PlayerInfo(12)=(PlayerName="Rebel",Deaths=4)
				DefaultWeapon=Class'RLMelee.RLMelee'
				MaxSpectators=16
				ScoreBoardType=Class'Dev.RLScoreBoard'
				HUDType=Class'Dev.RLHUD'
				BleedingDamageMax=50
				bHumansOnly=False
				bCoopWeaponMode=True
				bBleedingEnabled=True
				bBleedingDamageEnabled=True
				bAllHealthStopsBleeding=True
				bBandagesStopBleeding=True
				bHandleDownloadMessaging=True
}
